/* Ett litet program som använder intervall för att ge en nedräkning
   till Julafton. En timer med ett annat intervall används för att skapa en
   animering med en jultomte. Det är endast förflyttningen i sidled som sker
   med JavaScript. Tomtens rörelse ligger i bilden, som är en gif-animation.
   Ljud läggs in i Audio-objekt. Dels musik, som kan startas/stoppas med
   en knapp och dels en ljudeffekt som startas genom klick på tomten. */
// --------------------------------------------------
// Globala variabler och konstanter
let countElem; 		    // Referens till elementen för dag, timme, minut, sekund
let xmasEveTime;	    // Tiden i millisekunder för julafton
let santaAnimElem;      // Element som tomten ska flyttas inom
let santaElem;			// Referens till element med jultomten
let dir = 1;            // Riktning för tomten, 0=vänster, 1=höger
const xStep = 3;	    // Antal pixlar som tomten ska flyttas i varje steg
const santaTime = 50;	// Tid mellan varje förflyttning
const music = new Audio("sound/JingleBells.mp3"); // Audio-objekt med musik
const hohoho = new Audio("sound/santa.mp3");      // Audio-objekt med tomtens skratt
hohoho.preload = "auto"; // Ladda in ljudet till webbläsarens cache
// --------------------------------------------------
// Initiering då webbsidan laddats in
function init() {
    countElem = document.querySelector("#counter");
    let now = new Date();
    let thisYear = now.getFullYear();
    let xmasEve = new Date(thisYear, 11, 24);
    xmasEveTime = xmasEve.getTime();
    countDown(); // Första anrop, så att räknaren visas redan från början
    setInterval(countDown, 1000);   // countDown anropas varje sekund

    santaAnimElem = document.querySelector("#santaAnim");
    santaElem = document.querySelector("#santa");
	santaElem.style.left = "0px";
	setInterval(moveSanta, santaTime);

	music.currentTime = 0;
	music.loop = true;
	document.getElementById("musicBtn").addEventListener("click",startStopMusic);

	santaElem.addEventListener("click",playSantaSound);
} // Slut init
window.addEventListener("load", init);
// --------------------------------------------------
// Nedräkning
function countDown() {
    let now = new Date(); // Date-objekt för tiden just nu
    let nowTime = now.getTime(); // Tiden i milliskeunder just nu
    let remaining = (xmasEveTime - nowTime) / 1000;		// Återstående tid i sekunder
    let d = parseInt(remaining / 86400);				// 86400=60*60*24 sek. per dag
    remaining = parseInt(remaining % 86400);    // % är modulus, dvs rest vid heltalsdivision
    let h = parseInt(remaining / 3600);         // 3600 = 60*60 sek. per timme
    //if (h < 10) h = "0" + h;
    remaining = parseInt(remaining % 3600);
    let m = parseInt(remaining / 60);       // Minuter
    //if (m < 10) m = "0" + m;
    remaining = parseInt(remaining % 60);
    let s = parseInt(remaining % 86400);    // Sekunder
    //if (s < 10) s = "0" + s;
    countElem.innerHTML = d + " dagar<br>" + h + " tim. " + m + " min. " + s + " sek.";
} // Slut countDown
// --------------------------------------------------
// Flytta tomten stegvis åt höger / vänster
function moveSanta() {
    let p = santaAnimElem.getBoundingClientRect();
    let s = santaElem.getBoundingClientRect();
    let x = parseInt(santaElem.style.left);
    switch (dir) {
        case 0: // Vänster
            if (s.left - xStep >= p.left) {
                x -= xStep;
            }
            else { // Vänd tomten
                dir = 1;
                santaElem.style.transform = "rotateY(0)";
            }
            break;
        case 1: // Höger
            if (s.right + xStep <= p.right) {
                x += xStep;
            }
            else { // Vänd tomten
                dir = 0;
                santaElem.style.transform = "rotateY(180deg)";
            }
            break;
    }
    santaElem.style.left = x + "px";
} // Slut moveSanta
// --------------------------------------------------
// Starta eller stoppa musiken
function startStopMusic() {
	if (music.paused) music.play();
	else music.pause();
} // Slut startStopMusic
// --------------------------------------------------
// Spela upp tomtens skratt
function playSantaSound() {
	hohoho.play();
} // Slut playSantaSound
// --------------------------------------------------
